{$APPTYPE CONSOLE}
{$MAXSTACKSIZE 32000000}

uses SysUtils, Math;

const
  MaxN = 100*1000;
  FuncName = 'sum';
  SeparatorCharacters: set of char = ['(', ')', ','];
  VariableNameCharacters: set of char = ['A'..'Z', 'a'..'z', '0'..'9'];

type
  TArg = (left, rigth);
  StrList = array[1..MaxN] of string;

var
  ListIn, ListOut: StrList;
  ValidCharacters: set of char;
  i, k, FuncLen, OutLen, n, curr, OutCnt, AnsCnt, cnt, p: integer;
  StackArgs: array[1..MaxN] of TArg;
  sout, sans, t, token: string;
  fin, fout, fans: text;

procedure QSort(var list: StrList; l, r: integer);
var
  i, j: integer;
  x: string;
begin
  i := l; j := r; x := list[l+random(r-l)];
  repeat
    while(list[i] < x) do inc(i);
    while(list[j] > x) do dec(j);
    if i <= j then
      begin
        t := list[i]; list[i] := list[j]; list[j] := t;
        inc(i); dec(j);
      end;
  until i > j;
  if l < j then QSort(list, l, j);
  if i < r then QSort(list, i, r);
end;

procedure Ex(const s: string; ec: integer);
begin
  write(s);
  try
    close(fin); close(fout); close(fans);
  except
  end;
  halt(ec);
end;

begin
  randomize;
  FuncLen := length(FuncName);
  ValidCharacters :=  VariableNameCharacters + SeparatorCharacters;
  try
    assign(fin,paramstr(1)); reset(fin);
  except on e: Exception do
    Ex('Error opening input: ' + e.Message, 3);
  end;
  try
    assign(fans,paramstr(3)); reset(fans);
  except on e: Exception do
    Ex('Error opening answer: ' + e.Message, 3);
  end;
  try
    assign(fout,paramstr(2)); reset(fout);
  except on e: Exception do
    Ex('Can''t open output: ' + e.Message, 2);
  end;
  //read(fans, sans);
  //if length(sans) <> length(sout) then
  //  Ex('Incorrect length of the answer', 1);
  try
    readln(fin, n);
    for i := 1 to n do
      readln(fin, ListIn[i]);
  except on e: Exception do
    Ex('Invalid input: ' + e.Message, 3);
  end;
  QSort(ListIn, 1, n);
  try
    read(fout, sout);
  except on e: Exception do
    Ex(e.Message, 2);
  end;
  if not SeekEOF(fout) then
    Ex('More than one line', 2);
  if sout = '' then
    Ex('There''s no data in output', 2);
  AnsCnt := 0; k := 1;
  while k * 2 <= n do
    begin
      k := k * 2;
      inc(AnsCnt);
    end;
  if k < n then inc(AnsCnt);
  OutCnt := 0; cnt := 0;
  OutLen := length(sout);
  token := '';
  curr := 0; p := 0; k := 0;
  while curr < OutLen do
    begin
      inc(curr);
      if not (sout[curr] in ValidCharacters) and (curr < OutLen) then
        Ex(format('Invalid character ''%s''(code: %d) in %d position', [sout[curr], ord(sout[curr]), curr]), 2);
      if not (sout[curr] in SeparatorCharacters) then
        begin
          token := token + sout[curr];
        end
      else
        begin
          if (token <> FuncName) and (token <> '') then
            begin
              inc(p);
              if p > n then
                Ex('Too many arguments', 2);
              ListOut[p] := token;
            end;
          if (token = FuncName) and (sout[curr] <> '(') then
            Ex('There''s no argument of function', 2);
          case sout[curr] of
            '(':
            begin
              if token <> FuncName then
                Ex('Invalid function name', 2);
              inc(k); inc(cnt); OutCnt := Max(OutCnt, cnt);
              StackArgs[k] := left;
            end;
            ',':
              begin
                if StackArgs[k] = rigth then
                  Ex('More than two arguments of function', 2);
                StackArgs[k] := rigth;
              end;
            ')':
              begin
                if k = 0 then
                  Ex('Too many closing brackets', 2);
                if StackArgs[k] = left then
                  Ex('There''s only one argument of function', 2);
                dec(k); dec(cnt);
              end;
          end;          
          token := '';
        end;
    end;
  if sout[OutLen] <> ')' then
    Ex('Invalid last character: closing bracket expected', 2);
  if cnt <> 0 then
    Ex('Invalid brackets sequence', 2);
  if OutCnt = 0 then
    Ex('There''s no function', 2);
  if p < n then
    Ex('Too few arguments', 2);
  if OutCnt <> AnsCnt then
    Ex(format('Extra recursion depth: %d instead of %d', [OutCnt, AnsCnt]), 1);
  QSort(ListOut, 1, n); 
  for i := 1 to n do
    if ListIn[i] <> ListOut[i] then
      Ex('Invalid arguments', 2);
  Ex('ok', 0);
end.